package SOFA.GeneratedConnectors.H0000000000000006;

public class RMISkeleton extends java.rmi.server.UnicastRemoteObject implements SOFA.GeneratedConnectors.H0000000000000004.RMIInterface, SOFA.Connector.EEG.Types.Skeleton {

	protected SOFA.Connector.EEG.ConnectorManagerInterface manager;

	public void setManagerTie(SOFA.Connector.EEG.ConnectorManagerInterface manager) {
		this.manager=manager;
	}

	public SOFA.Connector.EEG.ConnectorManagerInterface getManagerTie() {
		return manager;
	}

	protected SOFA.GeneratedConnectors.H0000000000000002.CNInterface target;

	public void link(Object target) {
		this.target=(SOFA.GeneratedConnectors.H0000000000000002.CNInterface)target;
	}

	protected String rmiURL;

	public RMISkeleton() throws SOFA.Connector.ConnectorException, java.rmi.RemoteException {
		super();
		try {
			String rmihost = System.getProperty("sofa.rmihost", "localhost");
			String rmiport = System.getProperty("sofa.rmiport", "1099");
			SOFA.SOFAnode.Run.DeplDockRegistry.RgRMIDock rg = (SOFA.SOFAnode.Run.DeplDockRegistry.RgRMIDock) java.rmi.Naming.lookup("//"+rmihost+":"+rmiport+"/RgRMIDock");
			String xID = new java.rmi.server.UID().toString();
			rg.rebind("/SOFA/Connectors/EEG/EEM/Elements/RMISkeleton/"+xID, this);
			rmiURL="rmi://"+rmihost+":"+rmiport+"/SOFA/Connectors/EEG/EEM/Elements/RMISkeleton/"+xID;
		} catch (Exception e) {
			throw new SOFA.Connector.ConnectorException("Can't bind RMISkeleton to '"+rmiURL+"'.",e);
		}
	}

	public SOFA.Connector.TaggedProfile[] getProfiles() {
		return new SOFA.Connector.TaggedProfile[] { new SOFA.Connector.ECG.Profiles.RMIProfile(rmiURL) };
	}

	public String getFcItfName() throws java.rmi.RemoteException { return this.target.getFcItfName(); }

	public byte[] getFcItfOwner() throws java.rmi.RemoteException {
		SOFA.Connector.Reference ref = ((SOFA.Connector.RoleBase) this.target.getFcItfOwner()).getSOFAReference();
		ref = SOFA.Connector.Boot.DeplDockRMISkel.removeLocal(ref);
		cz.cuni.sofa.lib.Impl.ByteArrayOutputStream os = null;
		try {
			os = new cz.cuni.sofa.lib.Impl.ByteArrayOutputStream();
			ref._write(os);
		} catch (java.io.IOException e) {
			throw new SOFA.Connector.ConnectorTransportException("Can't serialize in the \"getFcItfOwner\".", e);
		}
		return os.toByteArray();
	}


	public void log(java.lang.String number, String thr_id) throws java.rmi.RemoteException {
		
		this.target.log(number, thr_id);
		return;
	}

}
