package SOFA.GeneratedConnectors.H0000000000000016;

public class DistributorImpl implements SOFA.GeneratedConnectors.H0000000000000008.CNInterface, SOFA.Connector.EEG.Types.Distributor {

	protected SOFA.Connector.EEG.ConnectorManagerInterface manager;

	public void setManagerTie(SOFA.Connector.EEG.ConnectorManagerInterface manager) {
		this.manager=manager;
	}

	public SOFA.Connector.EEG.ConnectorManagerInterface getManagerTie() {
		return manager;
	}

	protected java.util.HashSet listeners = new java.util.HashSet();

	public synchronized void link(Object listener) throws SOFA.Connector.LinkException {
		if (!listeners.add(listener)) {
			throw new SOFA.Connector.LinkException("Listener already present.");
		}
	}

	public synchronized void unlink(Object listener) throws SOFA.Connector.LinkException {
		if (!listeners.remove(listener)) {
			throw new SOFA.Connector.LinkException("Listener not found.");
		}
	}

	public org.objectweb.fractal.api.Type getFcItfType() { return null; }
	public boolean isFcInternalItf() { return false; }
	public String getFcItfName() { throw new SOFA.Connector.ConnectorTransportException("Interconection via EventPassing connector - getFcItfName is not supported."); }
	public org.objectweb.fractal.api.Component getFcItfOwner() { throw new SOFA.Connector.ConnectorTransportException("Interconection via EventPassing connector - getFcItfOwner is not supported."); }


	public void updateStatus(java.lang.String status, String thr_id) {
		synchronized (this) {
			java.util.Iterator iter=listeners.iterator();
			while (iter.hasNext()) {
				SOFA.GeneratedConnectors.H0000000000000008.CNInterface tgt=(SOFA.GeneratedConnectors.H0000000000000008.CNInterface)iter.next();
				tgt.updateStatus(status, thr_id);
			}
		}

	}

}
