package SOFA.GeneratedConnectors.H0000000000000003;

public class RMIStub implements SOFA.GeneratedConnectors.H0000000000000002.CNInterface, SOFA.Connector.EEG.Types.Stub {

	protected SOFA.Connector.EEG.ConnectorManagerInterface manager;

	public void setManagerTie(SOFA.Connector.EEG.ConnectorManagerInterface manager) {
		this.manager=manager;
	}

	public SOFA.Connector.EEG.ConnectorManagerInterface getManagerTie() {
		return manager;
	}

	protected SOFA.GeneratedConnectors.H0000000000000004.RMIInterface target;

	public void link(SOFA.Connector.TaggedProfile target) throws SOFA.Connector.LinkException {
		try {
			this.target=(SOFA.GeneratedConnectors.H0000000000000004.RMIInterface)java.rmi.Naming.lookup(((SOFA.Connector.ECG.Profiles.RMIProfile)target).URL);
		} catch (Exception e) {
			throw new SOFA.Connector.LinkException("Can't link to '"+((SOFA.Connector.ECG.Profiles.RMIProfile)target).URL+"'.",e);
		}
	}

	public String[] getSupportedProfiles() {
		return new String[] {"RMI"};
	}

	public org.objectweb.fractal.api.Type getFcItfType() { return null; }
	public boolean isFcInternalItf() { return false; }
	public String getFcItfName() { try { return this.target.getFcItfName(); } catch (java.rmi.RemoteException e) { throw new SOFA.Connector.ConnectorTransportException("Can't call method '::SOFA::demos::logdemo::LogInterface ::log'.",e); }}

	public org.objectweb.fractal.api.Component getFcItfOwner() {
		try {
			byte [] s = this.target.getFcItfOwner();
			SOFA.Connector.Reference ref = new SOFA.Connector.Reference ();
			ref._read(new cz.cuni.sofa.lib.Impl.ByteArrayInputStream(s));
			return (org.objectweb.fractal.api.Component) SOFA.Connector.Boot.DCUPComponentManagerConnector.createClt(ref);
		} catch (java.rmi.RemoteException e) {
			throw new SOFA.Connector.ConnectorTransportException("Remote exception in the \"getFcItfOwner\".", e);
		} catch (java.io.IOException e) {
			throw new SOFA.Connector.ConnectorTransportException("IOException in the \"getFcItfOwner\".", e);
		} catch (SOFA.Connector.ConnectorException e) {
			throw new SOFA.Connector.ConnectorTransportException("ConnectorException in the \"getFcItfOwner\".", e);
		}
	}


	public void log(java.lang.String number, String thr_id) {
		try {
			
			this.target.log(number, thr_id);
			return;
		} catch (java.rmi.RemoteException e) {
			throw new SOFA.Connector.ConnectorTransportException("Can't call method '::SOFA::demos::logdemo::LogInterface::log'.",e);
		}

	}

}
